#include <stdio.h>
void list_array(int pole[], int arrayLen)
{
    for(int i=0;i<arrayLen;i++)
    {
        printf("%d ",pole[i]);
    }
    printf("\n");
}

int main(void)
{
     const int arrayLen = 10;
     int myArray[arrayLen];
     int* pArray = myArray; // value from variable myArray is assigned to variable pArray
     int* pArray2 = &myArray; // wrong, address of variable array,
                              //not value of variable myArray (warning)

     for (int i = 0; i < arrayLen; i++) myArray[i] = i;
     list_array(myArray,arrayLen);
     printf("pArray=%p, *pArray=%d\n",pArray,*pArray);
     myArray[0] = 5; // OK, first item in myArray
     printf("myArray[0]=5:\n");
     list_array(myArray,arrayLen);
     printf("*(myArray + 0) = 6:\n");
     *(myArray + 0) = 6; // OK, first item in myArray
     //myArray = 10; // wrong, we are modifying address itself, not value on address
     list_array(myArray,arrayLen);
     pArray = myArray + 3; // pointer to 4th item in myArray
     printf("pArray=%p\t *pArray=%d\n",pArray,*pArray);

     //pArray = 5; // wrong, we are modifying address itself, not value on address
     *pArray = 5; // OK, 4th item
     pArray[0] = 5; // OK, 4th item
     *(myArray + 3) = 5; // OK, 4th item
     pArray[3] = 5; // OK, 7th item of myArray
     list_array(myArray,arrayLen);
     pArray++; // pointer to 5th item in myArray
     printf("pArray=%p, *pArray=%d\n",pArray, *pArray);
     pArray++; // pointer to 6th item in myArray
     printf("pArray=%p, *pArray=%d\n",pArray, *pArray);
     pArray--; // pointer to 5th item in myArray
     printf("pArray=%p, *pArray=%d\n",pArray, *pArray);

     int numItems = pArray - myArray; // should be 4 (myArray + 4 == pArray)
     printf("numItems = %d\n",numItems);
     return 0;
}

